---
title: Create component
description: Creates a new component.
breadcrumbs: Docs > API > Create component
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create component

## v2 (latest)

| Datadog site      | API endpoint                                                               |
| ----------------- | -------------------------------------------------------------------------- |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/statuspages/{page_id}/components     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/statuspages/{page_id}/components |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/statuspages/{page_id}/components |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/statuspages/{page_id}/components      |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/statuspages/{page_id}/components |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/statuspages/{page_id}/components |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/statuspages/{page_id}/components |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/statuspages/{page_id}/components      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/statuspages/{page_id}/components  |

### Overview

Creates a new component.

This endpoint requires the `status_pages_settings_write` permission.

OAuth apps require the `status_pages_settings_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#status-pages) to access this endpoint.

### Arguments

#### Path Parameters

| Field                | Type   | Description                |
| -------------------- | ------ | -------------------------- |
| page_id [*required*] | string | The ID of the status page. |

#### Query Strings

| Field   | Type   | Description                                                                                                                 |
| ------- | ------ | --------------------------------------------------------------------------------------------------------------------------- |
| include | string | Comma-separated list of resources to include. Supported values: created_by_user, last_modified_by_user, status_page, group. |

### Request

#### Body Data (required)

{% tabs %}
{% tab label="Model" %}
| Parent field  | Field                   | Type     | Description                                                                                       |
| ------------- | ----------------------- | -------- | ------------------------------------------------------------------------------------------------- |
|               | data                    | object   | The data object for creating a component.                                                         |
| data          | attributes [*required*] | object   | The supported attributes for creating a component.                                                |
| attributes    | components              | [object] | If creating a component of type `group`, the components to create within the group.               |
| components    | name [*required*]       | string   | The name of the grouped component.                                                                |
| components    | position [*required*]   | int64    | The zero-indexed position of the grouped component relative to the other components in the group. |
| components    | type [*required*]       | enum     | The type of the component. Allowed enum values: `component`.                                      |
| attributes    | name [*required*]       | string   | The name of the component.                                                                        |
| attributes    | position [*required*]   | int64    | The zero-indexed position of the component.                                                       |
| attributes    | type [*required*]       | enum     | The type of the component. Allowed enum values: `component`, `group`.                             |
| data          | relationships           | object   | The supported relationships for creating a component.                                             |
| relationships | group                   | object   | The group to create the component within.                                                         |
| group         | data [*required*]       | object   | The data object identifying the group to create the component within.                             |
| data          | id [*required*]         | uuid     | The ID of the group.                                                                              |
| data          | type [*required*]       | enum     | Components resource type. Allowed enum values: `components`. Default: `components`.               |
| data          | type [*required*]       | enum     | Components resource type. Allowed enum values: `components`. Default: `components`.               |
{% /tab %}

{% tab label="Example" %}
```json
{
  "data": {
    "attributes": {
      "name": "Logs",
      "position": 0,
      "type": "component"
    },
    "type": "components"
  }
}
```
{% /tab %}
{% /tabs %}

### Response

{% tabs %}
{% tab label="201" %}
Created

{% tabs %}
{% tab label="Model" %}
Response object for a single component.

| Parent field          | Field                          | Type      | Description                                                                                                                                                                                                                                                                                                                                                                   |
| --------------------- | ------------------------------ | --------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                       | data                           | object    | The data object for a component.                                                                                                                                                                                                                                                                                                                                              |
| data                  | attributes                     | object    | The attributes of a component.                                                                                                                                                                                                                                                                                                                                                |
| attributes            | components                     | [object]  | If the component is of type `group`, the components within the group.                                                                                                                                                                                                                                                                                                         |
| components            | id                             | uuid      | The ID of the component within the group. Read-only.                                                                                                                                                                                                                                                                                                                          |
| components            | name                           | string    | The name of the component within the group.                                                                                                                                                                                                                                                                                                                                   |
| components            | position                       | int64     | The zero-indexed position of the component within the group.                                                                                                                                                                                                                                                                                                                  |
| components            | status                         | enum      | The status of the component. Read-only. Allowed enum values: `operational`, `degraded`, `partial_outage`, `major_outage`, `maintenance`.                                                                                                                                                                                                                                      |
| components            | type                           | enum      | The type of the component. Allowed enum values: `component`.                                                                                                                                                                                                                                                                                                                  |
| attributes            | created_at                     | date-time | Timestamp of when the component was created.                                                                                                                                                                                                                                                                                                                                  |
| attributes            | modified_at                    | date-time | Timestamp of when the component was last modified.                                                                                                                                                                                                                                                                                                                            |
| attributes            | name                           | string    | The name of the component.                                                                                                                                                                                                                                                                                                                                                    |
| attributes            | position                       | int64     | The zero-indexed position of the component.                                                                                                                                                                                                                                                                                                                                   |
| attributes            | status                         | enum      | The status of the component. Allowed enum values: `operational`, `degraded`, `partial_outage`, `major_outage`, `maintenance`.                                                                                                                                                                                                                                                 |
| attributes            | type [*required*]              | enum      | The type of the component. Allowed enum values: `component`, `group`.                                                                                                                                                                                                                                                                                                         |
| data                  | id                             | uuid      | The ID of the component.                                                                                                                                                                                                                                                                                                                                                      |
| data                  | relationships                  | object    | The relationships of a component.                                                                                                                                                                                                                                                                                                                                             |
| relationships         | created_by_user                | object    | The Datadog user who created the component.                                                                                                                                                                                                                                                                                                                                   |
| created_by_user       | data [*required*]              | object    | The data object identifying the Datadog user who created the component.                                                                                                                                                                                                                                                                                                       |
| data                  | id [*required*]                | string    | The ID of the Datadog user who created the component.                                                                                                                                                                                                                                                                                                                         |
| data                  | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| relationships         | group                          | object    | The group the component belongs to.                                                                                                                                                                                                                                                                                                                                           |
| group                 | data [*required*]              | object    | The data object identifying the group the component belongs to.                                                                                                                                                                                                                                                                                                               |
| data                  | id [*required*]                | uuid      | The ID of the group the component belongs to.                                                                                                                                                                                                                                                                                                                                 |
| data                  | type [*required*]              | enum      | Components resource type. Allowed enum values: `components`. Default: `components`.                                                                                                                                                                                                                                                                                           |
| relationships         | last_modified_by_user          | object    | The Datadog user who last modified the component.                                                                                                                                                                                                                                                                                                                             |
| last_modified_by_user | data [*required*]              | object    | The data object identifying the Datadog user who last modified the component.                                                                                                                                                                                                                                                                                                 |
| data                  | id [*required*]                | string    | The ID of the Datadog user who last modified the component.                                                                                                                                                                                                                                                                                                                   |
| data                  | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| relationships         | status_page                    | object    | The status page the component belongs to.                                                                                                                                                                                                                                                                                                                                     |
| status_page           | data [*required*]              | object    | The data object identifying the status page the component belongs to.                                                                                                                                                                                                                                                                                                         |
| data                  | id [*required*]                | uuid      | The ID of the status page the component belongs to.                                                                                                                                                                                                                                                                                                                           |
| data                  | type [*required*]              | enum      | Status pages resource type. Allowed enum values: `status_pages`. Default: `status_pages`.                                                                                                                                                                                                                                                                                     |
| data                  | type [*required*]              | enum      | Components resource type. Allowed enum values: `components`. Default: `components`.                                                                                                                                                                                                                                                                                           |
|                       | included                       | [<oneOf>] | The included related resources of a component. Client must explicitly request these resources by name in the `include` query parameter.                                                                                                                                                                                                                                       |
| included              | <type=users>                   | object    | The included Datadog user resource.                                                                                                                                                                                                                                                                                                                                           |
| <type=users>          | attributes                     | object    | Attributes of the Datadog user.                                                                                                                                                                                                                                                                                                                                               |
| attributes            | email                          | string    | The email of the Datadog user.                                                                                                                                                                                                                                                                                                                                                |
| attributes            | handle                         | string    | The handle of the Datadog user.                                                                                                                                                                                                                                                                                                                                               |
| attributes            | icon                           | string    | The icon of the Datadog user.                                                                                                                                                                                                                                                                                                                                                 |
| attributes            | name                           | string    | The name of the Datadog user.                                                                                                                                                                                                                                                                                                                                                 |
| attributes            | uuid                           | string    | The UUID of the Datadog user.                                                                                                                                                                                                                                                                                                                                                 |
| <type=users>          | id                             | uuid      | The ID of the Datadog user.                                                                                                                                                                                                                                                                                                                                                   |
| <type=users>          | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| included              | <type=status_pages>            | object    | The included status page resource.                                                                                                                                                                                                                                                                                                                                            |
| <type=status_pages>   | attributes                     | object    | The attributes of a status page.                                                                                                                                                                                                                                                                                                                                              |
| attributes            | company_logo                   | string    | The base64-encoded image data displayed in the company logo.                                                                                                                                                                                                                                                                                                                  |
| attributes            | components                     | [object]  | Components displayed on the status page.                                                                                                                                                                                                                                                                                                                                      |
| components            | components                     | [object]  | If the component is of type `group`, the components within the group.                                                                                                                                                                                                                                                                                                         |
| components            | id                             | uuid      | The ID of the grouped component. Read-only.                                                                                                                                                                                                                                                                                                                                   |
| components            | name                           | string    | The name of the grouped component.                                                                                                                                                                                                                                                                                                                                            |
| components            | position                       | int64     | The zero-indexed position of the grouped component. Relative to the other components in the group.                                                                                                                                                                                                                                                                            |
| components            | status                         | enum      | The status of the component. Read-only. Allowed enum values: `operational`, `degraded`, `partial_outage`, `major_outage`, `maintenance`.                                                                                                                                                                                                                                      |
| components            | type                           | enum      | The type of the component. Allowed enum values: `component`.                                                                                                                                                                                                                                                                                                                  |
| components            | id                             | uuid      | The ID of the component. Read-only.                                                                                                                                                                                                                                                                                                                                           |
| components            | name                           | string    | The name of the component.                                                                                                                                                                                                                                                                                                                                                    |
| components            | position                       | int64     | The zero-indexed position of the component.                                                                                                                                                                                                                                                                                                                                   |
| components            | status                         | enum      | The status of the component. Read-only. Allowed enum values: `operational`, `degraded`, `partial_outage`, `major_outage`, `maintenance`.                                                                                                                                                                                                                                      |
| components            | type                           | enum      | The type of the component. Allowed enum values: `component`, `group`.                                                                                                                                                                                                                                                                                                         |
| attributes            | created_at                     | date-time | Timestamp of when the status page was created.                                                                                                                                                                                                                                                                                                                                |
| attributes            | custom_domain                  | string    | If configured, the url that the status page is accessible at.                                                                                                                                                                                                                                                                                                                 |
| attributes            | custom_domain_enabled          | boolean   | Whether the custom domain is configured.                                                                                                                                                                                                                                                                                                                                      |
| attributes            | domain_prefix                  | string    | The subdomain of the status page URL. Public pages use `https://{domain_prefix}.statuspage.datadoghq.com`, while private pages use `https://{domain_prefix}.private.statuspage.datadoghq.com`. Globally unique across Datadog Status Pages.                                                                                                                                   |
| attributes            | email_header_image             | string    | Base64-encoded image data included in email notifications sent to status page subscribers.                                                                                                                                                                                                                                                                                    |
| attributes            | email_notifications_enabled    | boolean   | Whether email notifications are enabled for the status page. Must be enabled when `subscriptions_enabled` is `true`.                                                                                                                                                                                                                                                          |
| attributes            | enabled                        | boolean   | Whether the status page is enabled.                                                                                                                                                                                                                                                                                                                                           |
| attributes            | favicon                        | string    | Base64-encoded image data displayed in the browser tab.                                                                                                                                                                                                                                                                                                                       |
| attributes            | modified_at                    | date-time | Timestamp of when the status page was last modified.                                                                                                                                                                                                                                                                                                                          |
| attributes            | ms_teams_subscriptions_enabled | boolean   | Whether Microsoft Teams subscriptions are enabled for the status page.                                                                                                                                                                                                                                                                                                        |
| attributes            | name                           | string    | The name of the status page.                                                                                                                                                                                                                                                                                                                                                  |
| attributes            | page_url                       | string    | The url that the status page is accessible at.                                                                                                                                                                                                                                                                                                                                |
| attributes            | rss_feed_enabled               | boolean   | Whether the RSS feed is enabled for the status page.                                                                                                                                                                                                                                                                                                                          |
| attributes            | slack_app_icon                 | string    | The Slack app icon URL for the status page.                                                                                                                                                                                                                                                                                                                                   |
| attributes            | slack_subscriptions_enabled    | boolean   | Whether Slack subscriptions are enabled for the status page.                                                                                                                                                                                                                                                                                                                  |
| attributes            | subscriptions_enabled          | boolean   | Whether users can subscribe to the status page.                                                                                                                                                                                                                                                                                                                               |
| attributes            | type                           | enum      | The type of the status page controlling how the status page is accessed. Public pages are accessible to anyone, internal pages are accessible to authenticated users in the Datadog organization, and private pages are accessible only to users matching an allow email access policy and no deny email access policy. Allowed enum values: `public`, `internal`, `private`. |
| attributes            | visualization_layout           | enum      | The layout of components on the status page. Defaults to `list`. `grid` requires `visualization_type` to be `component_name_only`; changing `visualization_type` to any other value resets the layout to `list`. Allowed enum values: `list`, `grid`.                                                                                                                         |
| attributes            | visualization_type             | enum      | The visualization type of the status page. Allowed enum values: `bars_and_uptime_percentage`, `bars_only`, `component_name_only`.                                                                                                                                                                                                                                             |
| <type=status_pages>   | id                             | uuid      | The ID of the status page.                                                                                                                                                                                                                                                                                                                                                    |
| <type=status_pages>   | relationships                  | object    | The relationships of a status page.                                                                                                                                                                                                                                                                                                                                           |
| relationships         | created_by_user                | object    | The Datadog user who created the status page.                                                                                                                                                                                                                                                                                                                                 |
| created_by_user       | data [*required*]              | object    | The data object identifying the Datadog user who created the status page.                                                                                                                                                                                                                                                                                                     |
| data                  | id [*required*]                | string    | The ID of the Datadog user who created the status page.                                                                                                                                                                                                                                                                                                                       |
| data                  | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| relationships         | last_modified_by_user          | object    | The Datadog user who last modified the status page.                                                                                                                                                                                                                                                                                                                           |
| last_modified_by_user | data [*required*]              | object    | The data object identifying the Datadog user who last modified the status page.                                                                                                                                                                                                                                                                                               |
| data                  | id [*required*]                | string    | The ID of the Datadog user who last modified the status page.                                                                                                                                                                                                                                                                                                                 |
| data                  | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| <type=status_pages>   | type [*required*]              | enum      | Status pages resource type. Allowed enum values: `status_pages`. Default: `status_pages`.                                                                                                                                                                                                                                                                                     |
| included              | <type=components>              | object    | The included component group resource.                                                                                                                                                                                                                                                                                                                                        |
| <type=components>     | attributes                     | object    | The attributes of a component group.                                                                                                                                                                                                                                                                                                                                          |
| attributes            | components                     | [object]  | If the component is of type `group`, the components within the group.                                                                                                                                                                                                                                                                                                         |
| components            | id                             | uuid      | The ID of the grouped component. Read-only.                                                                                                                                                                                                                                                                                                                                   |
| components            | name                           | string    | The name of the grouped component.                                                                                                                                                                                                                                                                                                                                            |
| components            | position                       | int64     | The zero-indexed position of the grouped component. Relative to the other components in the group.                                                                                                                                                                                                                                                                            |
| components            | status                         | enum      | The status of the component. Read-only. Allowed enum values: `operational`, `degraded`, `partial_outage`, `major_outage`, `maintenance`.                                                                                                                                                                                                                                      |
| components            | type                           | enum      | The type of the component. Allowed enum values: `component`.                                                                                                                                                                                                                                                                                                                  |
| attributes            | created_at                     | date-time | Timestamp of when the component was created.                                                                                                                                                                                                                                                                                                                                  |
| attributes            | modified_at                    | date-time | Timestamp of when the component was last modified.                                                                                                                                                                                                                                                                                                                            |
| attributes            | name                           | string    | The name of the component.                                                                                                                                                                                                                                                                                                                                                    |
| attributes            | position                       | int64     | The zero-indexed position of the component.                                                                                                                                                                                                                                                                                                                                   |
| attributes            | status                         | enum      | The status of the component. Allowed enum values: `operational`, `degraded`, `partial_outage`, `major_outage`, `maintenance`.                                                                                                                                                                                                                                                 |
| attributes            | type [*required*]              | enum      | The type of the component. Allowed enum values: `component`, `group`.                                                                                                                                                                                                                                                                                                         |
| <type=components>     | id                             | uuid      | The ID of the component.                                                                                                                                                                                                                                                                                                                                                      |
| <type=components>     | relationships                  | object    | The relationships of a component group.                                                                                                                                                                                                                                                                                                                                       |
| relationships         | created_by_user                | object    | The Datadog user who created the component group.                                                                                                                                                                                                                                                                                                                             |
| created_by_user       | data [*required*]              | object    | The data object identifying the Datadog user who created the component group.                                                                                                                                                                                                                                                                                                 |
| data                  | id [*required*]                | string    | The ID of the Datadog user who created the component group.                                                                                                                                                                                                                                                                                                                   |
| data                  | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| relationships         | group                          | object    | The group the component group belongs to.                                                                                                                                                                                                                                                                                                                                     |
| group                 | data [*required*]              | object    | The data object identifying the parent group of a component group.                                                                                                                                                                                                                                                                                                            |
| data                  | id [*required*]                | uuid      | The ID of the parent group.                                                                                                                                                                                                                                                                                                                                                   |
| data                  | type [*required*]              | enum      | Components resource type. Allowed enum values: `components`. Default: `components`.                                                                                                                                                                                                                                                                                           |
| relationships         | last_modified_by_user          | object    | The Datadog user who last modified the component group.                                                                                                                                                                                                                                                                                                                       |
| last_modified_by_user | data [*required*]              | object    | The data object identifying the Datadog user who last modified the component group.                                                                                                                                                                                                                                                                                           |
| data                  | id [*required*]                | string    | The ID of the Datadog user who last modified the component group.                                                                                                                                                                                                                                                                                                             |
| data                  | type [*required*]              | enum      | Users resource type. Allowed enum values: `users`. Default: `users`.                                                                                                                                                                                                                                                                                                          |
| relationships         | status_page                    | object    | The status page the component group belongs to.                                                                                                                                                                                                                                                                                                                               |
| status_page           | data [*required*]              | object    | The data object identifying the status page the component group belongs to.                                                                                                                                                                                                                                                                                                   |
| data                  | id [*required*]                | uuid      | The ID of the status page.                                                                                                                                                                                                                                                                                                                                                    |
| data                  | type [*required*]              | enum      | Status pages resource type. Allowed enum values: `status_pages`. Default: `status_pages`.                                                                                                                                                                                                                                                                                     |
| <type=components>     | type [*required*]              | enum      | Components resource type. Allowed enum values: `components`. Default: `components`.                                                                                                                                                                                                                                                                                           |
{% /tab %}

{% tab label="Example" %}
```json
{
  "data": {
    "attributes": {
      "components": [
        {
          "id": "string",
          "name": "string",
          "position": "integer",
          "status": "string",
          "type": "component"
        }
      ],
      "created_at": "2019-09-19T10:00:00.000Z",
      "modified_at": "2019-09-19T10:00:00.000Z",
      "name": "string",
      "position": "integer",
      "status": "operational",
      "type": "component"
    },
    "id": "string",
    "relationships": {
      "created_by_user": {
        "data": {
          "id": "",
          "type": "users"
        }
      },
      "group": {
        "data": {
          "id": "1234abcd-12ab-34cd-56ef-123456abcdef",
          "type": "components"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "",
          "type": "users"
        }
      },
      "status_page": {
        "data": {
          "id": "1234abcd-12ab-34cd-56ef-123456abcdef",
          "type": "status_pages"
        }
      }
    },
    "type": "components"
  },
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="429" %}
Too many requests

{% tabs %}
{% tab label="Model" %}
API error response.

| Field               | Type     | Description       |
| ------------------- | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    "Bad Request"
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}
{% /tabs %}

### Code Example

{% tabs %}
{% tab label="Curl" %}
```bash
# Path parameters
export page_id="1234abcd-12ab-34cd-56ef-123456abcdef"

# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/statuspages/${page_id}/components" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "name": "Logs",
      "position": 0,
      "type": "component"
    },
    "type": "components"
  }
}
EOF
```
{% /tab %}

{% tab label="Go" %}
```go
// Create component returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	// there is a valid "status_page" in the system
	StatusPageDataID := uuid.MustParse(os.Getenv("STATUS_PAGE_DATA_ID"))

	body := datadogV2.CreateComponentRequest{
		Data: &datadogV2.CreateComponentRequestData{
			Attributes: datadogV2.CreateComponentRequestDataAttributes{
				Name:     "Logs",
				Position: 0,
				Type:     datadogV2.CREATECOMPONENTREQUESTDATAATTRIBUTESTYPE_COMPONENT,
			},
			Type: datadogV2.STATUSPAGESCOMPONENTGROUPTYPE_COMPONENTS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStatusPagesApi(apiClient)
	resp, r, err := api.CreateComponent(ctx, StatusPageDataID, body, *datadogV2.NewCreateComponentOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StatusPagesApi.CreateComponent`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StatusPagesApi.CreateComponent`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
```
{% /tab %}

{% tab label="Java" %}
```java
// Create component returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StatusPagesApi;
import com.datadog.api.client.v2.model.CreateComponentRequest;
import com.datadog.api.client.v2.model.CreateComponentRequestData;
import com.datadog.api.client.v2.model.CreateComponentRequestDataAttributes;
import com.datadog.api.client.v2.model.CreateComponentRequestDataAttributesType;
import com.datadog.api.client.v2.model.StatusPagesComponent;
import com.datadog.api.client.v2.model.StatusPagesComponentGroupType;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    StatusPagesApi apiInstance = new StatusPagesApi(defaultClient);

    // there is a valid "status_page" in the system
    UUID STATUS_PAGE_DATA_ID = null;
    try {
      STATUS_PAGE_DATA_ID = UUID.fromString(System.getenv("STATUS_PAGE_DATA_ID"));
    } catch (IllegalArgumentException e) {
      System.err.println("Error parsing UUID: " + e.getMessage());
    }

    CreateComponentRequest body =
        new CreateComponentRequest()
            .data(
                new CreateComponentRequestData()
                    .attributes(
                        new CreateComponentRequestDataAttributes()
                            .name("Logs")
                            .position(0L)
                            .type(CreateComponentRequestDataAttributesType.COMPONENT))
                    .type(StatusPagesComponentGroupType.COMPONENTS));

    try {
      StatusPagesComponent result = apiInstance.createComponent(STATUS_PAGE_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StatusPagesApi#createComponent");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
```
{% /tab %}

{% tab label="Python" %}
```python
"""
Create component returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.status_pages_api import StatusPagesApi
from datadog_api_client.v2.model.create_component_request import CreateComponentRequest
from datadog_api_client.v2.model.create_component_request_data import CreateComponentRequestData
from datadog_api_client.v2.model.create_component_request_data_attributes import CreateComponentRequestDataAttributes
from datadog_api_client.v2.model.create_component_request_data_attributes_type import (
    CreateComponentRequestDataAttributesType,
)
from datadog_api_client.v2.model.status_pages_component_group_type import StatusPagesComponentGroupType

# there is a valid "status_page" in the system
STATUS_PAGE_DATA_ID = environ["STATUS_PAGE_DATA_ID"]

body = CreateComponentRequest(
    data=CreateComponentRequestData(
        attributes=CreateComponentRequestDataAttributes(
            name="Logs",
            position=0,
            type=CreateComponentRequestDataAttributesType.COMPONENT,
        ),
        type=StatusPagesComponentGroupType.COMPONENTS,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
with ApiClient(configuration) as api_client:
    api_instance = StatusPagesApi(api_client)
    response = api_instance.create_component(page_id=STATUS_PAGE_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
```
{% /tab %}

{% tab label="Ruby" %}
```ruby
# Create component returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
end
api_instance = DatadogAPIClient::V2::StatusPagesAPI.new

# there is a valid "status_page" in the system
STATUS_PAGE_DATA_ID = ENV["STATUS_PAGE_DATA_ID"]

body = DatadogAPIClient::V2::CreateComponentRequest.new({
  data: DatadogAPIClient::V2::CreateComponentRequestData.new({
    attributes: DatadogAPIClient::V2::CreateComponentRequestDataAttributes.new({
      name: "Logs",
      position: 0,
      type: DatadogAPIClient::V2::CreateComponentRequestDataAttributesType::COMPONENT,
    }),
    type: DatadogAPIClient::V2::StatusPagesComponentGroupType::COMPONENTS,
  }),
})
p api_instance.create_component(STATUS_PAGE_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" ruby "example.rb"
```
{% /tab %}

{% tab label="Rust" %}
```rust
// Create component returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_status_pages::CreateComponentOptionalParams;
use datadog_api_client::datadogV2::api_status_pages::StatusPagesAPI;
use datadog_api_client::datadogV2::model::CreateComponentRequest;
use datadog_api_client::datadogV2::model::CreateComponentRequestData;
use datadog_api_client::datadogV2::model::CreateComponentRequestDataAttributes;
use datadog_api_client::datadogV2::model::CreateComponentRequestDataAttributesType;
use datadog_api_client::datadogV2::model::StatusPagesComponentGroupType;

#[tokio::main]
async fn main() {
    // there is a valid "status_page" in the system
    let status_page_data_id = uuid::Uuid::parse_str(&std::env::var("STATUS_PAGE_DATA_ID").unwrap())
        .expect("Invalid UUID");
    let body = CreateComponentRequest::new().data(CreateComponentRequestData::new(
        CreateComponentRequestDataAttributes::new(
            "Logs".to_string(),
            0,
            CreateComponentRequestDataAttributesType::COMPONENT,
        ),
        StatusPagesComponentGroupType::COMPONENTS,
    ));
    let configuration = datadog::Configuration::new();
    let api = StatusPagesAPI::with_config(configuration);
    let resp = api
        .create_component(
            status_page_data_id.clone(),
            body,
            CreateComponentOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
```
{% /tab %}

{% tab label="TypeScript" %}
```typescript
/**
 * Create component returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
const apiInstance = new v2.StatusPagesApi(configuration);

// there is a valid "status_page" in the system
const STATUS_PAGE_DATA_ID = process.env.STATUS_PAGE_DATA_ID as string;

const params: v2.StatusPagesApiCreateComponentRequest = {
  body: {
    data: {
      attributes: {
        name: "Logs",
        position: 0,
        type: "component",
      },
      type: "components",
    },
  },
  pageId: STATUS_PAGE_DATA_ID,
};

apiInstance
  .createComponent(params)
  .then((data: v2.StatusPagesComponent) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" npx tsx "example.ts"
```
{% /tab %}
{% /tabs %}
